<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: CLScheduler Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="classes.xhtml"><span>Data&#160;Structure&#160;Index</span></a></li>
      <li><a href="inherits.xhtml"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.xhtml"><span>Data&#160;Fields</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classarm__compute_1_1_c_l_scheduler.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">CLScheduler Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Provides global access to a CL context and command queue.  
 <a href="classarm__compute_1_1_c_l_scheduler.xhtml#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a19bb5002a62b62e050e89c975f7b9fdf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a19bb5002a62b62e050e89c975f7b9fdf">default_init</a> ()</td></tr>
<tr class="memdesc:a19bb5002a62b62e050e89c975f7b9fdf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialises the context and command queue used by the scheduler to default values and sets a default device and kernel path for the <a class="el" href="classarm__compute_1_1_c_l_kernel_library.xhtml">CLKernelLibrary</a>.  <a href="#a19bb5002a62b62e050e89c975f7b9fdf">More...</a><br /></td></tr>
<tr class="separator:a19bb5002a62b62e050e89c975f7b9fdf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1a643e517f50bf0392fb6516dd7cf67"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#ae1a643e517f50bf0392fb6516dd7cf67">enqueue</a> (<a class="el" href="classarm__compute_1_1_i_c_l_kernel.xhtml">ICLKernel</a> &amp;kernel, bool flush=true)</td></tr>
<tr class="memdesc:ae1a643e517f50bf0392fb6516dd7cf67"><td class="mdescLeft">&#160;</td><td class="mdescRight">Schedule the execution of the passed kernel if possible.  <a href="#ae1a643e517f50bf0392fb6516dd7cf67">More...</a><br /></td></tr>
<tr class="separator:ae1a643e517f50bf0392fb6516dd7cf67"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbadebed3b89425740901b16b9d5d947"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#adbadebed3b89425740901b16b9d5d947">init</a> (cl::Context <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">context</a>=cl::Context::getDefault(), cl::CommandQueue <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">queue</a>=cl::CommandQueue::getDefault())</td></tr>
<tr class="memdesc:adbadebed3b89425740901b16b9d5d947"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialises the context and command queue to be used by the scheduler.  <a href="#adbadebed3b89425740901b16b9d5d947">More...</a><br /></td></tr>
<tr class="separator:adbadebed3b89425740901b16b9d5d947"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a252f5440564c77d68459f2baa978f86a"><td class="memItemLeft" align="right" valign="top">cl::Context &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">context</a> ()</td></tr>
<tr class="memdesc:a252f5440564c77d68459f2baa978f86a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accessor for the associated CL context.  <a href="#a252f5440564c77d68459f2baa978f86a">More...</a><br /></td></tr>
<tr class="separator:a252f5440564c77d68459f2baa978f86a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a293edc1bbcbddffb7228ac97917ed107"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a293edc1bbcbddffb7228ac97917ed107">set_context</a> (cl::Context <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">context</a>)</td></tr>
<tr class="memdesc:a293edc1bbcbddffb7228ac97917ed107"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accessor to set the CL context to be used by the scheduler.  <a href="#a293edc1bbcbddffb7228ac97917ed107">More...</a><br /></td></tr>
<tr class="separator:a293edc1bbcbddffb7228ac97917ed107"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad381d1aed28b4b1e1f5a710633934580"><td class="memItemLeft" align="right" valign="top">cl::CommandQueue &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">queue</a> ()</td></tr>
<tr class="memdesc:ad381d1aed28b4b1e1f5a710633934580"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accessor for the associated CL command queue.  <a href="#ad381d1aed28b4b1e1f5a710633934580">More...</a><br /></td></tr>
<tr class="separator:ad381d1aed28b4b1e1f5a710633934580"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9608e5af9f3a199f69ca6aa41b94359a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a9608e5af9f3a199f69ca6aa41b94359a">set_queue</a> (cl::CommandQueue <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">queue</a>)</td></tr>
<tr class="memdesc:a9608e5af9f3a199f69ca6aa41b94359a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Accessor to set the CL command queue to be used by the scheduler.  <a href="#a9608e5af9f3a199f69ca6aa41b94359a">More...</a><br /></td></tr>
<tr class="separator:a9608e5af9f3a199f69ca6aa41b94359a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad55f80ed3cd8b6c4f247763b747016af"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#ad55f80ed3cd8b6c4f247763b747016af">sync</a> ()</td></tr>
<tr class="memdesc:ad55f80ed3cd8b6c4f247763b747016af"><td class="mdescLeft">&#160;</td><td class="mdescRight">Blocks until all commands in the associated command queue have finished.  <a href="#ad55f80ed3cd8b6c4f247763b747016af">More...</a><br /></td></tr>
<tr class="separator:ad55f80ed3cd8b6c4f247763b747016af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6096d26e8e29e1a7f01b0f083fb7e33f"><td class="memItemLeft" align="right" valign="top">cl::Event&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a6096d26e8e29e1a7f01b0f083fb7e33f">enqueue_sync_event</a> ()</td></tr>
<tr class="memdesc:a6096d26e8e29e1a7f01b0f083fb7e33f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enqueues a marker into the associated command queue and return the event.  <a href="#a6096d26e8e29e1a7f01b0f083fb7e33f">More...</a><br /></td></tr>
<tr class="separator:a6096d26e8e29e1a7f01b0f083fb7e33f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a60f9a6836b628a7171914c4afe43b4a7"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml">CLScheduler</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#a60f9a6836b628a7171914c4afe43b4a7">get</a> ()</td></tr>
<tr class="memdesc:a60f9a6836b628a7171914c4afe43b4a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Access the scheduler singleton.  <a href="#a60f9a6836b628a7171914c4afe43b4a7">More...</a><br /></td></tr>
<tr class="separator:a60f9a6836b628a7171914c4afe43b4a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Provides global access to a CL context and command queue. </p>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00035">35</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a252f5440564c77d68459f2baa978f86a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">cl::Context&amp; context </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Accessor for the associated CL context. </p>
<dl class="section return"><dt>Returns</dt><dd>A CL context. </dd></dl>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00077">77</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>

<p>Referenced by <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00067">CLScheduler::init()</a>.</p>
<div class="fragment"><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    {</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordflow">return</span> _context;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    }</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a19bb5002a62b62e050e89c975f7b9fdf"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void default_init </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initialises the context and command queue used by the scheduler to default values and sets a default device and kernel path for the <a class="el" href="classarm__compute_1_1_c_l_kernel_library.xhtml">CLKernelLibrary</a>. </p>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00050">50</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>

<p>References <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml#ae1a643e517f50bf0392fb6516dd7cf67">CLScheduler::enqueue()</a>, <a class="el" href="classarm__compute_1_1_c_l_kernel_library.xhtml#aebe2d25607545d31f2b1ace6d60a81da">CLKernelLibrary::get()</a>, <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00067">CLScheduler::init()</a>, and <a class="el" href="_c_l_kernel_library_8h_source.xhtml#l00163">CLKernelLibrary::init()</a>.</p>

<p>Referenced by <a class="el" href="cl__convolution_8cpp_source.xhtml#l00053">main_cl_convolution()</a>, <a class="el" href="cl__events_8cpp_source.xhtml#l00033">main_cl_events()</a>, and <a class="el" href="neoncl__scale__median__gaussian_8cpp_source.xhtml#l00039">main_neoncl_scale_median_gaussian()</a>.</p>
<div class="fragment"><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <a class="code" href="classarm__compute_1_1_c_l_kernel_library.xhtml#aebe2d25607545d31f2b1ace6d60a81da">CLKernelLibrary::get</a>().<a class="code" href="classarm__compute_1_1_c_l_kernel_library.xhtml#af353532ea782387df6bcb6d01894f4ae">init</a>(<span class="stringliteral">&quot;./cl_kernels/&quot;</span>, cl::Context::getDefault(), cl::Device::getDefault());</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#adbadebed3b89425740901b16b9d5d947">init</a>(cl::Context::getDefault(), cl::CommandQueue::getDefault());</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    }</div><div class="ttc" id="classarm__compute_1_1_c_l_kernel_library_xhtml_af353532ea782387df6bcb6d01894f4ae"><div class="ttname"><a href="classarm__compute_1_1_c_l_kernel_library.xhtml#af353532ea782387df6bcb6d01894f4ae">arm_compute::CLKernelLibrary::init</a></div><div class="ttdeci">void init(std::string kernel_path=&quot;.&quot;, cl::Context context=cl::Context::getDefault(), cl::Device device=cl::Device::getDefault())</div><div class="ttdoc">Initialises the kernel library. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_kernel_library_8h_source.xhtml#l00163">CLKernelLibrary.h:163</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_kernel_library_xhtml_aebe2d25607545d31f2b1ace6d60a81da"><div class="ttname"><a href="classarm__compute_1_1_c_l_kernel_library.xhtml#aebe2d25607545d31f2b1ace6d60a81da">arm_compute::CLKernelLibrary::get</a></div><div class="ttdeci">static CLKernelLibrary &amp; get()</div><div class="ttdoc">Access the KernelLibrary singleton. </div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml_adbadebed3b89425740901b16b9d5d947"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml#adbadebed3b89425740901b16b9d5d947">arm_compute::CLScheduler::init</a></div><div class="ttdeci">void init(cl::Context context=cl::Context::getDefault(), cl::CommandQueue queue=cl::CommandQueue::getDefault())</div><div class="ttdoc">Initialises the context and command queue to be used by the scheduler. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_scheduler_8h_source.xhtml#l00067">CLScheduler.h:67</a></div></div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="ae1a643e517f50bf0392fb6516dd7cf67"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void enqueue </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classarm__compute_1_1_i_c_l_kernel.xhtml">ICLKernel</a> &amp;&#160;</td>
          <td class="paramname"><em>kernel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>flush</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Schedule the execution of the passed kernel if possible. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">kernel</td><td><a class="el" href="classarm__compute_1_1_kernel.xhtml" title="Kernel class. ">Kernel</a> to execute. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">flush</td><td>(Optional) Specifies if the command queue will be flushed after running the kernel. </td></tr>
  </table>
  </dd>
</dl>

<p>Referenced by <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00050">CLScheduler::default_init()</a>.</p>

</div>
</div>
<a class="anchor" id="a6096d26e8e29e1a7f01b0f083fb7e33f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">cl::Event enqueue_sync_event </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Enqueues a marker into the associated command queue and return the event. </p>
<dl class="section return"><dt>Returns</dt><dd>An event that can be waited on to block the executing thread. </dd></dl>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00119">119</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>

<p>Referenced by <a class="el" href="cl__events_8cpp_source.xhtml#l00033">main_cl_events()</a>.</p>
<div class="fragment"><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    {</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        cl::Event event;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        _queue.enqueueMarker(&amp;event);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordflow">return</span> event;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a60f9a6836b628a7171914c4afe43b4a7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml">CLScheduler</a>&amp; get </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Access the scheduler singleton. </p>
<dl class="section return"><dt>Returns</dt><dd>The scheduler </dd></dl>

<p>Referenced by <a class="el" href="cl__convolution_8cpp_source.xhtml#l00053">main_cl_convolution()</a>, <a class="el" href="cl__events_8cpp_source.xhtml#l00033">main_cl_events()</a>, <a class="el" href="neoncl__scale__median__gaussian_8cpp_source.xhtml#l00039">main_neoncl_scale_median_gaussian()</a>, <a class="el" href="_c_l_array_8h_source.xhtml#l00058">CLArray&lt; T &gt;::map()</a>, and <a class="el" href="_c_l_array_8h_source.xhtml#l00068">CLArray&lt; T &gt;::unmap()</a>.</p>

</div>
</div>
<a class="anchor" id="adbadebed3b89425740901b16b9d5d947"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void init </td>
          <td>(</td>
          <td class="paramtype">cl::Context&#160;</td>
          <td class="paramname"><em>context</em> = <code>cl::Context::getDefault()</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">cl::CommandQueue&#160;</td>
          <td class="paramname"><em>queue</em> = <code>cl::CommandQueue::getDefault()</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initialises the context and command queue to be used by the scheduler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">context</td><td>A CL context. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">queue</td><td>A CL command queue. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00067">67</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>

<p>References <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00077">CLScheduler::context()</a>, and <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00095">CLScheduler::queue()</a>.</p>

<p>Referenced by <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00050">CLScheduler::default_init()</a>.</p>
<div class="fragment"><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    {</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        _context = std::move(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">context</a>);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        _queue   = std::move(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">queue</a>);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    }</div><div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml_ad381d1aed28b4b1e1f5a710633934580"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">arm_compute::CLScheduler::queue</a></div><div class="ttdeci">cl::CommandQueue &amp; queue()</div><div class="ttdoc">Accessor for the associated CL command queue. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_scheduler_8h_source.xhtml#l00095">CLScheduler.h:95</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml_a252f5440564c77d68459f2baa978f86a"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">arm_compute::CLScheduler::context</a></div><div class="ttdeci">cl::Context &amp; context()</div><div class="ttdoc">Accessor for the associated CL context. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_scheduler_8h_source.xhtml#l00077">CLScheduler.h:77</a></div></div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="ad381d1aed28b4b1e1f5a710633934580"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">cl::CommandQueue&amp; queue </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Accessor for the associated CL command queue. </p>
<dl class="section return"><dt>Returns</dt><dd>A CL command queue. </dd></dl>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00095">95</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>

<p>Referenced by <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00067">CLScheduler::init()</a>.</p>
<div class="fragment"><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    {</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">return</span> _queue;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    }</div></div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a293edc1bbcbddffb7228ac97917ed107"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void set_context </td>
          <td>(</td>
          <td class="paramtype">cl::Context&#160;</td>
          <td class="paramname"><em>context</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Accessor to set the CL context to be used by the scheduler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">context</td><td>A CL context. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00086">86</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>
<div class="fragment"><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    {</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        _context = std::move(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">context</a>);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    }</div><div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml_a252f5440564c77d68459f2baa978f86a"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml#a252f5440564c77d68459f2baa978f86a">arm_compute::CLScheduler::context</a></div><div class="ttdeci">cl::Context &amp; context()</div><div class="ttdoc">Accessor for the associated CL context. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_scheduler_8h_source.xhtml#l00077">CLScheduler.h:77</a></div></div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="a9608e5af9f3a199f69ca6aa41b94359a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void set_queue </td>
          <td>(</td>
          <td class="paramtype">cl::CommandQueue&#160;</td>
          <td class="paramname"><em>queue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Accessor to set the CL command queue to be used by the scheduler. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">queue</td><td>A CL command queue. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00104">104</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>
<div class="fragment"><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    {</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        _queue = std::move(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">queue</a>);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div><div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml_ad381d1aed28b4b1e1f5a710633934580"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml#ad381d1aed28b4b1e1f5a710633934580">arm_compute::CLScheduler::queue</a></div><div class="ttdeci">cl::CommandQueue &amp; queue()</div><div class="ttdoc">Accessor for the associated CL command queue. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_scheduler_8h_source.xhtml#l00095">CLScheduler.h:95</a></div></div>
</div><!-- fragment -->
</div>
</div>
<a class="anchor" id="ad55f80ed3cd8b6c4f247763b747016af"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void sync </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Blocks until all commands in the associated command queue have finished. </p>

<p>Definition at line <a class="el" href="_c_l_scheduler_8h_source.xhtml#l00110">110</a> of file <a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a>.</p>

<p>Referenced by <a class="el" href="cl__convolution_8cpp_source.xhtml#l00053">main_cl_convolution()</a>, <a class="el" href="cl__events_8cpp_source.xhtml#l00033">main_cl_events()</a>, and <a class="el" href="neoncl__scale__median__gaussian_8cpp_source.xhtml#l00039">main_neoncl_scale_median_gaussian()</a>.</p>
<div class="fragment"><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    {</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        _queue.finish();</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    }</div></div><!-- fragment -->
</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>arm_compute/runtime/CL/<a class="el" href="_c_l_scheduler_8h_source.xhtml">CLScheduler.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacearm__compute.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml">CLScheduler</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:10 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
